<?php
/*------------------------------------------------------------------------
# com_contentfake - Content Fake
# ------------------------------------------------------------------------
# author    Francisco Javier Félix Belmonte 
# copyright Copyright (C) 2012 www.inode64.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.inode64.com
# Technical Support:  http://www.inode64.com/Codigo/Joomla/Componente-CONTENT_FAKE-para-la-creacion-de-contenidos-falsos.html
-------------------------------------------------------------------------*/
defined('_JEXEC') or die('Restricted access');
 
jimport('joomla.application.component.modelitem');
 
class ContentFakeModelContentFake extends JModelItem
{
	protected $item;
 
	public function getTable($type = 'ContentFake', $prefix = 'ContentFakeTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}

	private function rgb2array($rgb) {
	        return array(
		        base_convert(substr($rgb, 0, 2), 16, 10),
		        base_convert(substr($rgb, 2, 2), 16, 10),
		        base_convert(substr($rgb, 4, 2), 16, 10),
	        );
	}

        private function create_image($file, $width, $height, $color)
	{

		$bgcolor = $this->rgb2array($color);

		$im = ImageCreate($width, $height);
		$bg = ImageColorAllocate($im, $bgcolor[0], $bgcolor[1], $bgcolor[2]);
		$text = $width . "x" . $height;

		$color4 = ImageColorAllocate($im,255 - $bgcolor[0],255 - $bgcolor[1],255 - $bgcolor[2]);

		$ang = 0;
		$font = $width / 8;
		// determine numeric center of image
		$size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
		$X = ($width - (abs($size[2]- $size[0])))/2;
		$Y = (($height - (abs($size[5] - $size[3])))/2 + (abs($size[5] - $size[3])));
		if ( $width < 50 ) {
			if ( $height < 50 ) {
				$ang = 45;
				$font = $width / 6;
			    	$size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
			        $X = ($width - $size[4]) / 2;
				$Y = ($height - $size[3]) / 2;
			} elseif ( $height > $width ) {
			    $ang = 90;
			    $font = $height / 16;
			    $size = ImageTTFBBox($font,$ang,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);
			    $X = ($width - $size[4]) / 2 + 2;
			    $Y = ($height - $size[3]) / 2;
			}
		}

		//places numeric information on image
		ImageTTFText($im,$font,$ang,($X-1),$Y,$color4,JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'VeraBd.ttf',$text);

		ImagePNG($im, $file);

		return;
	}

	private function get_n_words($longtext, $n)
	{
        	$first_n = preg_split('/[\s]+/',$longtext,$n,PREG_SPLIT_NO_EMPTY);
	        $first_n_count = count($first_n);
	        $returned = '';
	        for($i=0; $i<$n; $i++) {
		        if($i == $n - 1) {
		                $returned .= preg_replace('/([^\s]+).*$/',"\\1",$first_n[$i]);
		        }
		        else {
		                $returned .= $first_n[$i].' ';
			}
	    		if($i>=$first_n_count) break;
	        }
	        return $returned;
	} 

	private function get_n_phrases($longtext, $n)
	{
        	$first_n = preg_split('/[\.]+/',$longtext,$n,PREG_SPLIT_NO_EMPTY);
	        $first_n_count = count($first_n);
	        $returned = '';
	        for($i=0; $i<$n; $i++) {
		        if($i == $n - 1) {
		                $returned .= preg_replace('/([^\.]+).*$/',"\\1",$first_n[$i]) .'.';
		        }
		        else {
		                $returned .= $first_n[$i].'.';
			}
	    		if($i>=$first_n_count) break;
	        }
	        return $returned;
	} 

	private function get_n_paragraphs($longtext, $n)
	{
        	$first_n = preg_split('/[\|]+/',$longtext,$n,PREG_SPLIT_NO_EMPTY);
	        $first_n_count = count($first_n);
	        $returned = '';
	        for($i=0; $i<$n; $i++) {
		        if($i == $n - 1) {
		                $returned .= preg_replace('/([^\|]+).*$/',"\\1",$first_n[$i]) .'|';
		        }
		        else {
		                $returned .= $first_n[$i].'|';
			}
	    		if($i>=$first_n_count) break;
	        }
	        return $returned;
	} 


	public function getMsg() 
	{
		if (!isset($this->item)) 
		{
			$this->item = new stdClass();
			
			$id = JRequest::getInt('id');
			$type = JRequest::getInt('type');
			$count = JRequest::getInt('count');
			$mode = JRequest::getInt('mode');
			$textalign = JRequest::getInt('textalign');
			$table = $this->getTable();
 
			$table->load($id);

			$width = JRequest::getInt('width');
			$height = JRequest::getInt('height');
			$color = JRequest::getString('imagebgcolor');
	    		$md = md5("$width $height $color");

			switch (JRequest::getInt('textposition'))
			{
			case 4:
				$style = 'none';
				break;
			case 3:
				$style = 'justify';
				break;
			case 2:
				$style = 'center';
				break;
			case 1:
				$style = 'right';
				break;
			default:
			case 0:
				$style = 'left';
				break;
			}

                        switch (JRequest::getInt('imageposition'))
                        {
                        case 2:
                                $this->item->imageposition = 'right';
                                break;
                        case 1:
                                $this->item->imageposition = 'left';
                                break;
                        default:
                        case 0:
                                $this->item->imageposition = 'none';
                                break;
                        }

			$this->item->dimension  = $width . 'px X ' . $height . 'px';
			$this->item->imagemargin = JRequest::getString('imagemargin');

            		if (!JFile::exists(JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.$md.'.png')){
                    		$this->create_image(JPATH_SITE.DIRECTORY_SEPARATOR.'media'.DIRECTORY_SEPARATOR.'contentfake'.DIRECTORY_SEPARATOR.'images'.DIRECTORY_SEPARATOR.$md.'.png',$width, $height, $color);
            		}
            		$this->item->image = JURI::root().'media/contentfake/images/'.$md.'.png';
 
			$table->content .= '|' . $table->content;

			switch ($type)
			{
			case 3:
    				$this->item->text = $this->get_n_paragraphs($table->content, $count);
				break;
			case 2:
    				$this->item->text = $this->get_n_phrases($table->content, $count);
				break;
			case 1:
    				$this->item->text = $this->get_n_words($table->content, $count);
				break;
			default:
			case 0:
    				$this->item->text = substr($table->content, 0, $count);
				break;
			}

			switch ($mode)
			{
			case 2:
				$this->item->text = str_replace ('|', '<br />', $this->item->text);
				break;
			case 1:
				$this->item->text = '<div>' . str_replace ('|', '</div><div>', $this->item->text) . '</div>';
				break;
			default:
			case 0:
				$this->item->text = '<p>' . str_replace ('|', '</p><p>', $this->item->text) . '</p>';
				break;
			}

			$this->item->text = "<div style='text-align:$style'>" . $this->item->text . "</div>";
			if ($style == 'none' )
			{
                    		$this->item->text = '';
			}
	    
		}
		return $this->item;
	}
}
?>
